<?php

namespace yifang\db\concern;

/**
 * 事务支持
 */
trait Transaction
{
    /**
     * 执行数据库Xa事务
     * @return mixed
     */
    public function transactionXa(callable $callback, array $dbs = [])
    {
        return $this->connection->transactionXa($callback, $dbs);
    }

    /**
     * 执行数据库事务
     * @return mixed
     */
    public function transaction(callable $callback)
    {
        return $this->connection->transaction($callback);
    }

    /**
     * 启动事务
     * @return void
     */
    public function startTrans()
    {
        $this->connection->startTrans();
    }

    /**
     * 用于非自动提交状态下面的查询提交
     * @return void
     */
    public function commit()
    {
        $this->connection->commit();
    }

    /**
     * 事务回滚
     * @return void
     */
    public function rollback()
    {
        $this->connection->rollback();
    }

    /**
     * 启动XA事务
     * @return void
     */
    public function startTransXa($xid)
    {
        $this->connection->startTransXa($xid);
    }

    /**
     * 预编译XA事务
     * @return void
     */
    public function prepareXa($xid)
    {
        $this->connection->prepareXa($xid);
    }

    /**
     * 提交XA事务
     * @return void
     */
    public function commitXa($xid)
    {
        $this->connection->commitXa($xid);
    }

    /**
     * 回滚XA事务
     * @return void
     */
    public function rollbackXa($xid)
    {
        $this->connection->rollbackXa($xid);
    }
}
